#import "Controller.h"
#import "EBShape.h"
#import "EBShapeVendor.h"
#import "EBShapeControl.h"

@implementation Controller

- (void) applicationDidFinishLaunching: (NSNotification *) notification
{
  EBShape *aShape;

  aShape = [EBShape squareShape];
  [squareVendor setShape: aShape];

  aShape = [EBShape circleShape];
  [circleVendor setShape: aShape];

  aShape = [EBShape triangleShape];
  [triangleVendor setShape: aShape];

  [shapeControl registerForDraggedTypes: [NSArray arrayWithObject: @"EBShape"]];
  [shapeControl2 registerForDraggedTypes: [NSArray arrayWithObject: @"EBShape"]];
}

- (void) control: (EBShapeControl *) shapeControl
         didDraw: (BOOL) flag
           point: (NSPoint) p
{
  if(!flag){
    [pointField setStringValue: @""];
  }else{
    [pointField setStringValue: NSStringFromPoint(p)];
  }
}

@end


