/* EBShape.h created by eb on Mon 14-Dec-1998 */

#import <AppKit/AppKit.h>

typedef enum {
  EBNoShape = 0,
  EBSquare,
  EBCircle,
  EBTriangle
} EBShapeType;

@interface EBShape : NSObject
{
  EBShapeType shapeType;
}

+ (EBShape *) shapeWithType: (EBShapeType) aType;
+ (EBShape *) squareShape;
+ (EBShape *) circleShape;
+ (EBShape *) triangleShape;

- initWithType: (EBShapeType) aType;
- (void) encodeWithCoder: (NSCoder *) coder;
- initWithCoder: (NSCoder *) coder;

- (int) shapeType;
- (void) setShapeType: (EBShapeType) aType;

- (BOOL) shapeAtCenterPoint: (NSPoint) center
              containsPoint: (NSPoint) aPoint;

- (BOOL) shapeAtOriginPoint: (NSPoint) origin
              containsPoint: (NSPoint) aPoint;

- (NSRect) shapeFrameWithCenter: (NSPoint) center;
- (NSRect) shapeFrameWithOrigin: (NSPoint) origin;
@end

@interface EBShape(Drawing)
- (void) drawShapeAtCenterPoint: (NSPoint) aPoint;
- (void) drawShapeAtOriginPoint: (NSPoint) aPoint;
- (void) drawShapeInRect: (NSRect) aRect;
- (void) drawShapeInInteriorRect: (NSRect) aRect;
- (void) drawNoShapeInRect: (NSRect) aRect;
- (void) drawSquareInRect: (NSRect) aRect;
- (void) drawCircleInRect: (NSRect) aRect;
- (void) drawTriangleInRect: (NSRect) aRect;
- (NSImage *) dragImage;
@end
