/* EBShapeControl.h created by eb on Mon 14-Dec-1998 */

#import <AppKit/AppKit.h>
#import "EBShapeVendor.h"

@interface EBShapeControl : EBShapeVendor
{
  NSPoint location;
  NSPoint draggingOrigin;
  BOOL isDragging;
}

- init;
- (NSPoint) location;
- (void) setLocation: (NSPoint) aLocation;
- (NSPoint) draggingOrigin;
- (void) setDraggingOrigin: (NSPoint) aPoint;
- (BOOL) isDragging;
- (void) setIsDragging: (BOOL) flag;

- (BOOL) shapeContainsPoint: (NSPoint) aPoint;
- (NSRect) shapeFrame;
@end

@interface EBShapeControl(Drawing)
- (void) drawShapeInRect: (NSRect) aRect;
- (void) drawPoint: (NSPoint) p;
@end

@interface EBShapeControl(EventHandling)
- (void) mouseDownOnShape: (NSEvent *) event;
@end

@interface EBShapeControl(InternalDragging)
- (void) startInternalDragOnEvent: (NSEvent *) event;
- (void) updateLocationFromDragEvent: (NSEvent *) event
                              offset: (NSPoint) offset;
@end

@interface EBShapeControl(DraggingDestination)
- (unsigned int)draggingEntered:(id <NSDraggingInfo>)sender;
- (unsigned int)draggingUpdated:(id <NSDraggingInfo>)sender;
- (void)draggingExited:(id <NSDraggingInfo>)sender;
- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender;
- (void)concludeDragOperation:(id <NSDraggingInfo>)sender;
@end

@interface NSObject(EBShapeControlDelegateMethods)
- (void) control: (EBShapeControl *) shapeControl
         didDraw: (BOOL) flag
           point: (NSPoint) p;
@end


