/* EBShapeVendor.h created by eb on Mon 14-Dec-1998 */

#import <AppKit/AppKit.h>
#import "EBShape.h"

#define DelegateHandles(a) (delegate && [delegate respondsToSelector:@selector(a)])

@interface EBShapeVendor : NSControl
{
  EBShape *shape;
  id delegate;
}

- init;
- (void) dealloc;
- (EBShape *) shape;
- (void) setShape: (EBShape *) aShape;
- delegate;
- (void) setDelegate: (id) aDelegate;

- (BOOL) shapeContainsPoint: (NSPoint) aPoint;
- (NSRect) shapeFrame;
@end

@interface EBShapeVendor(Drawing)
- (void) drawRect: (NSRect) aRect;
- (void) drawBackgroundInRect: (NSRect) aRect;
- (void) drawShapeInRect: (NSRect) aRect;
@end

@interface EBShapeVendor(EventHandling)
- (void)mouseDown: (NSEvent *)event;
- (void) mouseDownOnShape: (NSEvent *) event;
@end

@interface EBShapeVendor(DraggingSource)
- (void) startExternalDragOnEvent: (NSEvent *) event;
- (void) declareAndSetShapeOnPasteboard: (NSPasteboard *) pb;
- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)flag;
@end

@interface NSObject(EBShapeVendorDelegateMethods)
- (BOOL)                control: (EBShapeVendor *) control
 shouldStartExternalDragOnEvent: (NSEvent *) anEvent;
- (void)                control: (EBShapeVendor *) control
   didFinishExternalDragOnEvent: (NSEvent *) anEvent;
@end

